blog/urls.py
from django.urls import path, register_converter
from . import views

app_name = 'blog'


class BooleanConverter:
    regex = 'True|False'

    def to_python(self, value):
        return value == 'True'

    def to_url(self, value):
        return str(value)


register_converter(BooleanConverter, "bool")

urlpatterns = [
    # Article CRU(D)
    path('article/create/', views.create_article, name='create_article'),
    path('', views.article_list, name='blog_index'),
    path('article/<uuid:pk>/', views.article_detail, name='article_detail'),
    path(
        'article/<uuid:pk>/<bool:incr_views>/', views.article_detail, name='article_detail_from_comment'
    ),
    path('article/update/<uuid:pk>/', views.update_article, name='update_article'),
    path('article/search/', views.search_article, name='search_article'),
    path('article/comment/like_dislike', views.like_dislike_comment),
]

projet_docker_s3/urls.py
from django.contrib import admin
from django.urls import path, include

API_PREFIX = 'projet_docker_s3/'

urlpatterns = [
    path(API_PREFIX+'admin/', admin.site.urls),  # admin
    path(API_PREFIX+'blog/', include('blog.urls')),  # blog
    path(API_PREFIX+'auth/', include('authentication.urls')),  # blog
]

blog/models.py
import uuid
from django.db import models
from django.contrib.auth.models import User


class Article(models.Model):
    id = models.UUIDField(primary_key=True, default=uuid.uuid4, editable=False)
    title = models.CharField(max_length=200)
    content = models.TextField()
    author = models.ForeignKey(User, on_delete=models.CASCADE)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)


class Comment(models.Model):
    id = models.UUIDField(primary_key=True, default=uuid.uuid4, editable=False)
    article = models.ForeignKey(Article, on_delete=models.CASCADE, related_name='comments')
    author = models.ForeignKey(User, on_delete=models.CASCADE)
    content = models.TextField()
    created_at = models.DateTimeField(auto_now_add=True)

    def get_likes_count(self):
        return Like.objects.filter(comment=self, is_like=True).count()

    def get_dislikes_count(self):
        return Like.objects.filter(comment=self, is_like=False).count()
    

class Like(models.Model):
    id = models.UUIDField(primary_key=True, default=uuid.uuid4, editable=False)
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    comment = models.ForeignKey(Comment, on_delete=models.CASCADE)
    is_like = models.BooleanField(default=True)  # True for like, False for dislike

blog/forms.py
from django import forms
from .models import Article, Comment


class ArticleForm(forms.ModelForm):
    class Meta:
        model = Article
        fields = ['title', 'content']


class CommentForm(forms.ModelForm):
    class Meta:
        model = Comment
        fields = ['content']

blog/views.py
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.shortcuts import render, redirect
from .models import Article, Comment, Like
from django.core.cache import cache
from .forms import ArticleForm, CommentForm
from django.http import JsonResponse
import json


@login_required
def create_article(request):
    """
    Crée un nouvel article
    """
    if request.method == "POST":
        form = ArticleForm(request.POST)
        if form.is_valid():
            article = form.save(commit=False)
            article.author = request.user
            form.save()
            cache.set(f'article_{article.pk}', article, timeout=300)
            return redirect('blog:article_detail', pk=article.pk)
    else:
        form = ArticleForm()

    return_data = {
        'form': form
    }
    return render(request, 'article_form.html', return_data)


@login_required(login_url='blog:login')
def update_article(request, pk):
    """
    Met à jour un article
    """
    article = Article.objects.get(pk=pk)
    if request.method == "POST":
        form = ArticleForm(request.POST, instance=article)
        if form.is_valid():
            form.save()
            cache.set(f'article_{pk}', article, timeout=300)
            return redirect('blog:article_detail', pk=article.pk)
    else:
        form = ArticleForm(instance=article)

    return_data = {
        'form': form
    }
    return render(request, 'article_form.html', return_data)


def article_list(request):
    """
    Affiche la liste des articles
    """
    articles = Article.objects.all()
    return render(request, 'article_list.html', {'articles': articles})


def article_detail(request, pk, incr_views=True):
    """
    Affiche un article et ses commentaires

    :param request:
    :param pk: Clé primaire de l'article à afficher
    :param incr_views: Incrémenter le compteur de vues ou non
    """
    # Récupération de l'article à afficher
    article = cache.get(f'article_{pk}')
    if not article:
        article = Article.objects.get(pk=pk)
        cache.set(f'article_{pk}', article, timeout=300)

    # Création de commentaires
    comment_form = CommentForm()
    if request.method == 'POST':
        comment_form = CommentForm(request.POST)
        if comment_form.is_valid():
            new_comment = comment_form.save(commit=False)
            new_comment.article = article
            new_comment.author = request.user
            new_comment.save()

            comments = article.comments.all()
            cache.set(f'comments_for_{pk}', comments, timeout=300)
            return redirect('blog:article_detail_from_comment', pk=pk, incr_views=False)

    # Récupération des commentaires
    comments = cache.get(f'comments_for_{pk}')
    if not comments:
        comments = article.comments.all()
        cache.set(f'comments_for_{pk}', comments, timeout=300)
    for comment in comments:
        comment.likes = cache.get(f'comment_likes_{comment.pk}', 0)
        comment.dislikes = cache.get(f'comment_dislikes_{comment.pk}', 0)
        if request.user.is_authenticated:
            comment_user_like = Like.objects.filter(comment=comment, user=request.user).first()
            if comment_user_like:
                comment.user_like = comment_user_like.is_like

    views_key = f'article_views_{pk}'
    views = cache.get(views_key, 0)
    if incr_views:
        cache.set(views_key, views + 1, timeout=None)
    views = cache.get(views_key)

    return_data = {
        'article': article,
        'views': views,
        'comments': comments,
        'comment_form': comment_form,
    }
    return render(request, 'article_detail.html', return_data)


def like_dislike_comment(request):
    """
    Gère les likes et dislikes des commentaires
    """
    if request.method == 'POST' and request.user.is_authenticated:
        data = json.loads(request.body)
        comment_id = data.get('comment_id')
        action = data.get('action')
        if not comment_id:
            return JsonResponse({'error': 'Comment id is missing'}, status=400)
        if action is None or action not in ['like', 'dislike', 'cancel']:
            return JsonResponse({'error': 'Invalid action'}, status=400)

        comment = Comment.objects.get(pk=comment_id)
        try:
            like = Like.objects.get(comment=comment, user=request.user)
            if action == 'like':
                like.is_like = True
                like.save()
            elif action == 'dislike':
                like.is_like = False
                like.save()
            else:
                like.delete()
        except Like.DoesNotExist:
            if action == 'like':
                Like.objects.create(comment=comment, user=request.user, is_like=True)
            elif action == 'dislike':
                Like.objects.create(comment=comment, user=request.user, is_like=False)
            else:
                return JsonResponse({'error': 'Invalid action'}, status=400)

        cache.set(f'comment_likes_{comment.pk}', comment.get_likes_count(), timeout=None)
        cache.set(f'comment_dislikes_{comment.pk}', comment.get_dislikes_count(), timeout=None)

        likes_count = comment.get_likes_count()
        dislikes_count = comment.get_dislikes_count()

        return JsonResponse({'likes_count': likes_count, 'dislikes_count': dislikes_count})

    return JsonResponse({'error': 'Invalid request'})


def search_article(request):
    """
    Recherche un article
    """
    if request.method == 'POST':
        search_term = request.POST.get('search_term')
        articles = Article.objects.filter(title__icontains=search_term)
        messages.add_message(
            request, messages.INFO,
            'Voici les articles correspondant à votre recherche')
        return render(request, 'article_list.html',
                      {'articles_filtered': articles})

    return render(request, 'article_list.html', {'articles': []})

blog/templates/article_detail.html
{% extends 'base.html' %}

{% block title %}Liste des articles{% endblock %}
{% block content %}
    <div>
        <a class="btn btn-primary" href="{% url 'blog:blog_index' %}">Retour à la liste des articles</a>
        {% if user.is_authenticated and user == article.author %}
            <a class="btn btn-primary" href="{% url 'blog:update_article' article.pk %}">Modifier cet article</a>
        {% endif %}
    </div>
    <div class="d-flex">
        <h2>{{ article.title }} ({{views}} vues)</h2>  <h5 class="align-self-center">- écrit par {{ article.author }}</h5>
    </div>
    <p>{{ article.content }}</p>
    <hr>
    <h3>Commentaires</h3>
    {% for comment in article.comment_set.all %}
        <p>{{ comment.content }}</p>
    {% endfor %}

{% if user.is_authenticated %}
<form method="post">
  {% csrf_token %}
  {{ comment_form.as_p }}
  <button class="btn btn-primary" type="submit">Ajouter un commentaire</button>
</form>
{% else %}
<p>Vous devez être connecté pour ajouter un commentaire</p>
{% endif %}
<hr>
{% for comment in comments %}
<div class="comment">
  <p>{{ comment.author }} (publié le {{comment.created_at|date:"d/m/Y à H:i"}})</p>
  <p>{{ comment.content }}</p>
  <p>
      <!--      LIKES       -->
      {% if comment.user_like == True %}
          <i class="bi bi-hand-thumbs-up like-btn btn btn-lg text-primary fw-bold liked" id="{{comment.id}}_likes_icon" data-comment-id="{{comment.id}}"></i>
          <span class="likes-count" id="{{comment.id}}_likes">{{ comment.likes }}</span>
      {% else %}
          <i class="bi bi-hand-thumbs-up like-btn btn btn-lg" id="{{comment.id}}_likes_icon" data-comment-id="{{comment.id}}"></i>
          <span class="likes-count" id="{{comment.id}}_likes">{{ comment.likes }}</span>
      {% endif %}
      <!--      DISLIKES       -->
        {% if comment.user_like == False %}
            <i class="bi bi-hand-thumbs-down dislike-btn btn btn-lg text-danger fw-bold disliked" id="{{comment.id}}_dislikes_icon" data-comment-id="{{comment.id}}"></i>
            <span class="dislikes-count" id="{{comment.id}}_dislikes">{{ comment.dislikes }}</span>
        {% else %}
            <i class="bi bi-hand-thumbs-down dislike-btn btn btn-lg" id="{{comment.id}}_dislikes_icon" data-comment-id="{{comment.id}}"></i>
            <span class="dislikes-count" id="{{comment.id}}_dislikes">{{ comment.dislikes }}</span>
        {% endif %}
  </p>
</div>
{% endfor %}

<script>
    <!-- Add click event listeners on like/dislikes icons-->
    const likeBtns = document.querySelectorAll('.like-btn');
    const dislikeBtns = document.querySelectorAll('.dislike-btn');
    // Define a request variable to reuse for both like and dislike buttons
    function update_like_dislike(commentId){
        const request = new Request(
            '/projet_docker_s3/blog/article/comment/like_dislike',
            {headers:{'X-CSRFToken': '{{ csrf_token }}',
                    'Content-Type': 'application/json'}}
        );
        // Check if it is a like, a dislike or a cancel
        let isLiked = document.getElementById(commentId + '_likes_icon').classList.contains('liked');
        let isDisliked = document.getElementById(commentId + '_dislikes_icon').classList.contains('disliked');
        // define action as like, dislike or cancel
        let action = '';
        if (isLiked){
            action = 'like';
        } else if (isDisliked){
            action = 'dislike';
        } else {
            action = 'cancel';
        }
        fetch(request, {
                method: 'POST',
                mode: 'same-origin',
                body: JSON.stringify({
                    comment_id: commentId,
                    action: action
                })
            }).then(function (response) {}
            ).then(function (data) {}
            ).catch(function (error) {console.log(error);});
    }

    // CLICK EVENT LISTENER FOR LIKE BUTTONS
    likeBtns.forEach(function (likeBtn) {
        likeBtn.addEventListener('click', function () {
            let isLiked = likeBtn.classList.contains('liked');
            let dislikeBtn = likeBtn.closest('.comment').querySelector('.dislike-btn');
            let commentId = likeBtn.dataset.commentId;
            let likesCount = document.getElementById(commentId + '_likes');
            let dislikesCount = document.getElementById(commentId + '_dislikes');

            if (!isLiked) {
                const likesCountValue = parseInt(likesCount.textContent);
                likesCount.textContent = likesCountValue + 1;

                // Toggle Bootstrap classes for button appearance
                likeBtn.classList.toggle('text-primary');
                likeBtn.classList.toggle('fw-bold');
                likeBtn.classList.toggle('liked');


                // If disliked, remove dislike
                if (dislikeBtn.classList.contains('disliked')) {
                    dislikesCount.textContent = dislikesCount.textContent - 1;
                    dislikeBtn.classList.remove('disliked', 'text-danger', 'fw-bold');
                }
            } else {
                // If already liked, remove the like
                likesCount.textContent = likesCount.textContent - 1;
                likeBtn.classList.remove('text-primary', 'fw-bold', 'liked');
            }
            update_like_dislike(commentId);
        });
    });
    // CLICK EVENT LISTENER FOR DISLIKE BUTTONS
    dislikeBtns.forEach(function (dislikeBtn) {
        dislikeBtn.addEventListener('click', function () {
            let isDisliked = dislikeBtn.classList.contains('disliked');
            let likeBtn = dislikeBtn.closest('.comment').querySelector('.like-btn');
            let commentId = dislikeBtn.dataset.commentId;
            let likesCount = document.getElementById(commentId + '_likes');
            let dislikesCount = document.getElementById(commentId + '_dislikes');

            if (!isDisliked) {
                // You can send an AJAX request to increment the dislikes count on the server
                // For simplicity, let's just increment the count on the client side
                const dislikesCountValue = parseInt(dislikesCount.textContent);
                dislikesCount.textContent = dislikesCountValue + 1;

                // Toggle a class to indicate that the user has disliked this comment
                dislikeBtn.classList.toggle('text-danger');
                dislikeBtn.classList.toggle('fw-bold');
                dislikeBtn.classList.toggle('disliked');

                // If liked, remove like
                if (likeBtn.classList.contains('liked')) {
                    likesCount.textContent = likesCount.textContent - 1;
                    likeBtn.classList.remove('liked', 'text-primary', 'fw-bold');
                }
            } else {
                // If already disliked, remove the dislike
                dislikesCount.textContent = dislikesCount.textContent - 1;
                dislikeBtn.classList.remove('disliked', 'text-danger', 'fw-bold');
            }
            update_like_dislike(commentId);
        });
    });
</script>
{% endblock %}

blog/templates/article_form.html
<a href="{% url 'blog:blog_index' %}">Retour à la liste des articles</a>
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Enregistrer</button>
</form>

blog/templates/article_list.html
{% extends 'base.html' %}

{% block title %}Liste des articles{% endblock %}
{% block content %}
    <div class="card w-75 mx-auto">
        <div class="card-header">
            Articles
        </div>
        <ul class="list-group list-group-flush">
            {% if articles_filtered %}
                {% for article in articles_filtered %}
                    <li class="list-group-item">
                        <h2><a href="{% url 'blog:article_detail' article.pk %}">{{ article.title }}</a></h2>
                        <h6>{{ article.content | slice:":100" }}...</h6>
                    </li>
                {% endfor %}
            {% else %}
                {% for article in articles %}
                    <li class="list-group-item">
                        <h2><a href="{% url 'blog:article_detail' article.pk %}">{{ article.title }}</a></h2>
                        <h6>{{ article.content | slice:":100" }}...</h6>
                    </li>
                {% endfor %}
            {% endif %}
        </ul>
    </div>
{% endblock %}